{$V-,X+}

Program CTL;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    CTL

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Demonstrates the use of the CTLRead function.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU;

Var
  CtlFile     : Text;                { Variables needed to read the CTL file }
  Ident       : String;
  Value       : String;
  LineNum     : Word;

  MenuFile    : String;                   { Variables used to store CTL data }
  HelpFile    : String;
  InfoFile    : String;


Begin { CTL }
  DorInit;                                        { Initialise the Door Unit }

  MenuFile:='';
  HelpFile:='';
  InfoFile:='';

  Assign (CtlFile,DorPath+'Ctl.Ctl');                     { Open the CTLfile }
  {$I-} Reset (CtlFile); {$I+}
  If IoResult=0 then
  Begin
    While not CtlRead (CtlFile,LineNum,Ident,Value) do        { Get an entry }
    Begin
      If Ident='DOORMENUFILE' then MenuFile:=Value else
      If Ident='DOORHELPFILE' then HelpFile:=Value else
      If Ident='DOORINFOFILE' then InfoFile:=Value else
      Begin
        WriteLn (' Error reading CTL ',DorPath,'CTL.CTL');
        WriteLn (' UnKnown identifier ''',Ident,''' in line ',LineNum);
        WriteLn (' Please correct and run again!');
        Close (CtlFile);
        Halt;
      End;  { If }
    End;  { While }

    Close (CtlFile);

    WriteLn ('Values found in CTL file:');
    WriteLn;
    WriteLn ('DoorMenuFile: ',MenuFile);
    WriteLn ('DoorHelpFile: ',HelpFile);
    WriteLn ('DoorInfoFile: ',InfoFile);

  End  { If }
  Else
    WriteLn ('Error opening ',DorPath,'CTL.CTL.');
End.  { CTL }
