{$V-,X+}

Program Display;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    Display

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Demonstrates the use of the DorDisplay function.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU;

Var
  Key         : Char;

Begin { Display }
  DorInit;                                        { Initialise the Door Unit }

  Repeat
    Key:=UpCase(DorDisplay ('Display','DdEeQq',False));          { Show file }

    Case Key of
      #0 : Key:=UpCase(GetKey ('DdEeQq'+#13));          { No key was pressed }
      #1 : Begin
             WriteLn ('Error opening DISPLAY.A*..');        { File not found }
             Halt;
           End;  { File not found }
    End;  { Case }

    ClrScr;

    If Key in ['D','E'] then
    Begin
      Case Key of
        'D' : Key:=DorDisplay ('Display.Pas','Ss',True);
        'E' : Key:=DorDisplay ('EditLine.Pas','Ss',True);
      End;  { Case }
      WriteLn;
      WriteLn;
      Case Key of
        #0 : WriteLn ('File displayed entirely.');
        #1 : WriteLn ('File not found.');
        #2 : WriteLn ('File aborted at more prompt.');
      Else
        WriteLn ('File aborted with "',Key,'" key.');
      End;  { Case }
      Write (RalGet(ralRtnCont),^A);
    End;  { If }
  Until Key='Q';
End.  { Display }
