(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

                                         
                                           
                                           
                                         
                                        
                                           
                                         

                      Remote   Access   Door   Unit   v3.10

              (c) 1990,91,92,93,98 by AquiSystems Software Dev NL.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Const
  ExtKey_AltA       = 30;                                           { Alt-A }
  ExtKey_AltB       = 48;                                           { Alt-B }
  ExtKey_AltC       = 46;                                           { Alt-C }
  ExtKey_AltD       = 32;                                           { Alt-D }
  ExtKey_AltE       = 18;                                           { Alt-E }
  ExtKey_AltF       = 33;                                           { Alt-F }
  ExtKey_AltG       = 34;                                           { Alt-G }
  ExtKey_AltH       = 35;                                           { Alt-H }
  ExtKey_AltI       = 23;                                           { Alt-I }
  ExtKey_AltJ       = 36;                                           { Alt-J }
  ExtKey_AltK       = 37;                                           { Alt-K }
  ExtKey_AltL       = 38;                                           { Alt-L }
  ExtKey_AltM       = 50;                                           { Alt-M }
  ExtKey_AltN       = 49;                                           { Alt-N }
  ExtKey_AltO       = 24;                                           { Alt-O }
  ExtKey_AltP       = 25;                                           { Alt-P }
  ExtKey_AltQ       = 16;                                           { Alt-Q }
  ExtKey_AltR       = 19;                                           { Alt-R }
  ExtKey_AltS       = 31;                                           { Alt-S }
  ExtKey_AltT       = 20;                                           { Alt-T }
  ExtKey_AltU       = 22;                                           { Alt-U }
  ExtKey_AltV       = 47;                                           { Alt-V }
  ExtKey_AltW       = 17;                                           { Alt-W }
  ExtKey_AltX       = 45;                                           { Alt-X }
  ExtKey_AltY       = 21;                                           { Alt-Y }
  ExtKey_AltZ       = 44;                                           { Alt-Z }
  ExtKey_Alt0       = 120;                                          { Alt-0 }
  ExtKey_Alt1       = 121;                                          { Alt-1 }
  ExtKey_Alt2       = 122;                                          { Alt-2 }
  ExtKey_Alt3       = 123;                                          { Alt-3 }
  ExtKey_Alt4       = 124;                                          { Alt-4 }
  ExtKey_Alt5       = 125;                                          { Alt-5 }
  ExtKey_Alt6       = 126;                                          { Alt-6 }
  ExtKey_Alt7       = 127;                                          { Alt-7 }
  ExtKey_Alt8       = 128;                                          { Alt-8 }
  ExtKey_Alt9       = 129;                                          { Alt-9 }
  ExtKey_AltMinus   = 130;                                          { Alt-- }
  ExtKey_AltEqual   = 131;                                          { Alt-= }

  ExtKey_F1         = 59;                                              { F1 }
  ExtKey_F2         = 60;                                              { F2 }
  ExtKey_F3         = 61;                                              { F3 }
  ExtKey_F4         = 62;                                              { F4 }
  ExtKey_F5         = 63;                                              { F5 }
  ExtKey_F6         = 64;                                              { F6 }
  ExtKey_F7         = 65;                                              { F7 }
  ExtKey_F8         = 66;                                              { F8 }
  ExtKey_F9         = 67;                                              { F9 }
  ExtKey_F10        = 68;                                             { F10 }
  ExtKey_F11        = 133;                                            { F11 }
  ExtKey_F12        = 134;                                            { F12 }

  ExtKey_AltF1      = 104;                                         { Alt-F1 }
  ExtKey_AltF2      = 105;                                         { Alt-F2 }
  ExtKey_AltF3      = 106;                                         { Alt-F3 }
  ExtKey_AltF4      = 107;                                         { Alt-F4 }
  ExtKey_AltF5      = 108;                                         { Alt-F5 }
  ExtKey_AltF6      = 109;                                         { Alt-F6 }
  ExtKey_AltF7      = 110;                                         { Alt-F7 }
  ExtKey_AltF8      = 111;                                         { Alt-F8 }
  ExtKey_AltF9      = 112;                                         { Alt-F9 }
  ExtKey_AltF10     = 113;                                        { Alt-F10 }
  ExtKey_AltF11     = 139;                                        { Alt-F11 }
  ExtKey_AltF12     = 140;                                        { Alt-F12 }

  ExtKey_ShiftF1    = 84;                                        { Shift-F1 }
  ExtKey_ShiftF2    = 85;                                        { Shift-F2 }
  ExtKey_ShiftF3    = 86;                                        { Shift-F3 }
  ExtKey_ShiftF4    = 87;                                        { Shift-F4 }
  ExtKey_ShiftF5    = 88;                                        { Shift-F5 }
  ExtKey_ShiftF6    = 89;                                        { Shift-F6 }
  ExtKey_ShiftF7    = 90;                                        { Shift-F7 }
  ExtKey_ShiftF8    = 91;                                        { Shift-F8 }
  ExtKey_ShiftF9    = 92;                                        { Shift-F9 }
  ExtKey_ShiftF10   = 93;                                       { Shift-F10 }
  ExtKey_ShiftF11   = 135;                                      { Shift-F11 }
  ExtKey_ShiftF12   = 136;                                      { Shift-F12 }

  ExtKey_CtrlF1     = 94;                                         { Ctrl-F1 }
  ExtKey_CtrlF2     = 95;                                         { Ctrl-F2 }
  ExtKey_CtrlF3     = 96;                                         { Ctrl-F3 }
  ExtKey_CtrlF4     = 97;                                         { Ctrl-F4 }
  ExtKey_CtrlF5     = 98;                                         { Ctrl-F5 }
  ExtKey_CtrlF6     = 99;                                         { Ctrl-F6 }
  ExtKey_CtrlF7     = 100;                                        { Ctrl-F7 }
  ExtKey_CtrlF8     = 101;                                        { Ctrl-F8 }
  ExtKey_CtrlF9     = 102;                                        { Ctrl-F9 }
  ExtKey_CtrlF10    = 103;                                       { Ctrl-F10 }
  ExtKey_CtrlF11    = 137;                                       { Ctrl-F11 }
  ExtKey_CtrlF12    = 138;                                       { Ctrl-F12 }

  ExtKey_Nul        = 3;                                              { Nul }
  ExtKey_ShiftTab   = 15;                                       { Shift TAB }
  ExtKey_Home       = 71;                                            { Home }
  ExtKey_End        = 79;                                             { End }
  ExtKey_Up         = 72;                                              { Up }
  ExtKey_Left       = 75;                                            { Left }
  ExtKey_Right      = 77;                                           { Right }
  ExtKey_Down       = 80;                                            { Down }
  ExtKey_PgDn       = 81;                                            { PgDn }
  ExtKey_PgUp       = 73;                                            { PgUp }
  ExtKey_Ins        = 82;                                             { Ins }
  ExtKey_Del        = 83;                                             { Del }
  
  ExtKey_CtrlPrtScr = 114;                                    { Ctrl-PrtScr }
  ExtKey_CtrlLeft   = 115;                               { Ctrl-Cursor-Left }
  ExtKey_CtrlRight  = 116;                              { Ctrl-Cursor-Right }
  ExtKey_CtrlHome   = 119;                                      { Ctrl-Home }
  ExtKey_CtrlEnd    = 117;                                       { Ctrl-End }
  ExtKey_CtrlPgDn   = 118;                                      { Ctrl-PgDn }
  ExtKey_CtrlPgUp   = 132;                                      { Ctrl-PgUp }

