{$V-,X+}

Program Hotkeys;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    Hotkeys

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Demonstrates the use of the hotkey routines.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU;

Var
  Keys        : String;
  Key         : Char;

Begin { Hotkeys }
  DorInit;                                       { Initialises the Door Unit }

  Keys:='AaBbCcDdEeFfGgHhIiJj';                                { The hotkeys }

  Repeat
    ClrScr;
    DorSetHotKeys (Keys);                    { Inform RADU about the hotkeys }

    GotoXY (10,WhereY); DupWrite ('',60); WriteLn;
    GotoXY (30,WhereY); WriteLn ('[A] Choice A........');
    GotoXY (30,WhereY); WriteLn ('[B] Choice B........');
    GotoXY (30,WhereY); WriteLn ('[C] Choice C........');
    GotoXY (30,WhereY); WriteLn ('[D] Choice D........');
    GotoXY (30,WhereY); WriteLn ('[E] Choice E........');
    GotoXY (30,WhereY); WriteLn ('[F] Choice F........');
    GotoXY (30,WhereY); WriteLn ('[G] Choice G........');
    GotoXY (30,WhereY); WriteLn ('[H] Choice H........');
    GotoXY (30,WhereY); WriteLn ('[I] Choice I........');
    GotoXY (30,WhereY); WriteLn ('[J] Choice J........');
    GotoXY (10,WhereY); DupWrite ('',60); WriteLn;

    If HotKeyPressed then
      Key:=HotReadKey       { If a hotkey was pressed during display, get it }
    Else
      Key:=GetKey(Keys+#13);                        { Otherwise wait for one }

    DorSetHotKeys ('');                               { Stop hotkey checking }
  Until Key<>#13;                    { Redisplay menu when enter was pressed }

  ClrScr;
  WriteLn ('You''ve chosen ',UpCase(Key));
  ReadLn;
End.  { Hotkeys }
