{$V-,X+}

Program Page;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    Page

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Example program to demonstrate the use of RaPage, RaYell and
              DorPage. Various other RADU procedures are also used. Please
              be sure you have a PAGE.RA file in the current directory, or
              in the directory pointed to by the RA environment variable.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU,
  Chat;

Var
  Reason      : String;
  PagePrompt  : String;

Begin { Page }
  DorInit;                                        { Initalises the Door Unit }

  ClrScr;

  If RaYell then                                       { If sound is allowed }
  Begin

    PagePrompt:=RalGet(ralAskWhy);
    GotoXY(40-Length(PagePrompt) div 2,WhereY);
    WriteLn (PagePrompt);
    WriteLn;
    GotoXY (5,WhereY);
    Write (RaConfig.LeftBracket);
    DupWrite('-',68);
    WriteLn (RaConfig.RightBracket);

    Reason:='';
    GotoXY (6,WhereY);
    DorLineEdit (Reason,68,[#32..#255],[#13],' ');              { Ask reason }
    WriteLn;

    If Reason<>'' then
    Begin

      WriteLn;
      WriteLn (CrtOutput,' Press C to chat or A to abort page.');
      Write ('Now paging the sysop. Press space to abort.');
      RaLog ('Reason for chat: '+Reason);                       { LOG reason }

      Case UpCase(DorPage ('AaCc'+#27,' ','')) of
        'C' : Begin                                    { Sysop likes to chat }
                RaLog ('Sysop paged (Chatted with user)'); { Write LOG entry }
                DorChat;                          { Invoke internal chatmode }
              End; { If }
        ' ' : WriteLn ('Aborted..');
      Else                                              { Aborted or Timeout }
        RaLog ('Sysop paged (Not available)');             { Write LOG entry }
        WriteLn;
        WriteLn (RalGet(ralNotAvail));
      End;  { Case }

    End;  { If }
  End
  Else
  Begin
    WriteLn ('Sorry, the sysop cannot be paged right now..');
    RaLog ('Sysop paged (Outside paging hours).');
  End;  { Else }

  Write (RalGet(ralRtnCont),^A);
End.  { Page }
