{$V-,X+}

Program RaduCode;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    RaduCode

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Demonstrates the use of the RADU codes.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU;

Begin { RaduCode }
  DorInit;
  Write ('`S:');
  WriteLn('`c:`y2:`h:The RADU codes!`y+1:`l:');
  WriteLn('`x5:The `h:RADU`l: codes are designed to release you from the very often');
  WriteLn('`x5:used commands `h:GotoXY`l:, `h:TextColor`l:, `h:TextBackGround`l: and `h:WriteLn`l:.');
  WriteLn('`x5:Especially when you want to make your program look a bit fancy,');
  WriteLn('`x5:you can get pretty `h:mad`l: of all these commands, that do just a `h:small`l:');
  WriteLn('`x5:change. The `h:RADU`l: codes completely eliminates all this non-sense!');
  WriteLn('`x5:Now you can perform these actions with just `h:ONE`l: command: `h:WriteLn`l:!');
  WriteLn('`x5:In the beginning the `h:RADU`l: codes can look a bit complex, but');
  WriteLn('`x5:once you get used to it, you can''t live without it anymore`h:!`l:');
  WriteLn('`x5:Just look at this source, and see for yourself how few lines were');
  WriteLn('`x5:needed for this text, and only WriteLn is used! Let''s now do some');
  WriteLn('`x5:nice things with these codes.`y+1:');
  WriteLn('`x5:`h:`l: Character `h:d`d117,20:plication`l:, with one simple command!');
  WriteLn('`x5:`h:`l: Easy `f3:c`f9:o`f5:l`f11:o`f2:r`a7: change commands.');
  WriteLn('`x5:`h:`l: Cursor movement codes!`g1,1:',^W,'`y+10:',^W,'`x+20:',^W,'`y10:',^W,'`x-5:',^W,'`g70,21:',^W);
  WriteLn('`g1,1:',^W,'`y+10:',^W,'`x+20:',^W,'`y10:',^W,'`x-5:',^W,'`g70,21:',^W,'`g1,1:',^W,'`y+10:',^W,'`x+20:',^W);
  WriteLn('`y10:',^W,'`x-5:',^W,'`g70,21:',^W,'`y19:');
  WriteLn('`c:and..... Text `h:centering`l:!!`y+1:');
  WriteLn('`c:Now look at the source, and see how `h:easy`l: this all works!');

{

  (*
     The following code does exactly the same as the code above, except
     that no RADU codes are used.
  *)
  ClrScr;
  GotoXY (33,2);
  HighVideo;
  WriteLn('The RADU codes!');
  LowVideo;
  WriteLn;
  GotoXY (5,WhereY);
  Write('The ');
  HighVideo;
  Write('RADU');
  LowVideo;
  WriteLn(' codes are designed to release you from the very often');
  GotoXY (5,WhereY);
  Write('used commands ');
  HighVideo;
  Write('GotoXY');
  LowVideo;
  Write(', ');
  HighVideo;
  Write('TextColor');
  LowVideo;
  Write(', ');
  HighVideo;
  Write('TextBackGround');
  LowVideo;
  Write(' and ');
  HighVideo;
  Write('WriteLn');
  LowVideo;
  WriteLn('.');
  GotoXY (5,WhereY);
  WriteLn('Especially when you want to make your program look a bit fancy,');
  GotoXY (5,WhereY);
  Write('you can get pretty ');
  HighVideo;
  Write('mad');
  LowVideo;
  Write(' of all these commands, that do just a ');
  HighVideo;
  WriteLn('small');
  LowVideo;
  GotoXY (5,WhereY);
  Write('change. The ');
  HighVideo;
  Write('RADU');
  LowVideo;
  WriteLn(' codes completely eliminates all this non-sense!');
  GotoXY (5,WhereY);
  Write('Now you can perform these actions with just ');
  HighVideo;
  Write('ONE');
  LowVideo;
  Write(' command: ');
  HighVideo;
  Write('WriteLn');
  LowVideo;
  WriteLn('!');
  GotoXY(5,WhereY);
  Write('In the beginning the ');
  HighVideo;
  Write('RADU');
  LowVideo;
  WriteLn(' codes can look a bit complex, but');
  GotoXY (5,WhereY);
  Write('once you get used to it, you can''t live without it anymore');
  HighVideo;
  WriteLn('!');
  LowVideo;
  GotoXY(5,WhereY);
  WriteLn('Just look at this source, and see for yourself how few lines were');
  GotoXY(5,WhereY);
  WriteLn('needed for this text, and only WriteLn is used! Let''s now do some');
  GotoXY(5,WhereY);
  WriteLn('nice things with these codes.');
  WriteLn;
  GotoXY(5,WhereY);
  HighVideo;
  Write('');
  LowVideo;
  Write(' Character ');
  HighVideo;
  Write('duuuuuuuuuuuuuuuuuuuuplication');
  LowVideo;
  WriteLn(', with one simple command!');
  GotoXY(5,WhereY);
  HighVideo;
  Write('');
  LowVideo;
  Write(' Easy ');
  TextColor(3);
  Write('c');
  TextColor(9);
  Write('o');
  TextColor(5);
  Write('l');
  TextColor(11);
  Write('o');
  TextColor(2);
  Write('r');
  TextColor(7);
  WriteLn(' change commands.');
  GotoXY(5,WhereY);
  HighVideo;
  Write('');
  LowVideo;
  Write(' Cursor movement codes!');
  GotoXY(1,1);
  Delay(1000);
  GotoXY(WhereX,WhereY+10);
  Delay(1000);
  GotoXY(WhereX+20,WhereY);
  Delay(1000);
  GotoXY(WhereX,10);
  Delay(1000);
  GotoXY(WhereX-5,WhereY);
  Delay(1000);
  GotoXY(70,21);
  Delay(1000);
  GotoXY(1,1);
  Delay(1000);
  GotoXY(WhereX,WhereY+10);
  Delay(1000);
  GotoXY(WhereX+20,WhereY);
  Delay(1000);
  GotoXY(WhereX,10);
  Delay(1000);
  GotoXY(WhereX-5,WhereY);
  Delay(1000);
  GotoXY(70,21);
  Delay(1000);
  GotoXY(1,1);
  Delay(1000);
  GotoXY(WhereX,WhereY+10);
  Delay(1000);
  GotoXY(WhereX+20,WhereY);
  Delay(1000);
  GotoXY(WhereX,10);
  Delay(1000);
  GotoXY(WhereX-5,WhereY);
  Delay(1000);
  GotoXY(70,21);
  Delay(1000);
  GotoXY(28,20);
  Write('and..... Text ');
  HighVideo;
  Write('centering');
  LowVideo;
  WriteLn('!!');
  WriteLn;
  GotoXY(13,WhereY);
  Write('Now look at the source, and see how ');
  HighVideo;
  Write('easy');
  LowVideo;
  WriteLn(' this all works!');
}


  Write (^A);
End.  { RaduCode }
