Program Shuffle(Input,Output);

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

          (c) 1992,93,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    Shuffle

     Date:    July 14, 1994

   Author:    Hans Siemons, Prime Productions

  Purpose:    Demonstrates a complete doorgame.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

{$V-,X+}

Uses Radu,
     MiscRADU;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Const SVersion='V1.10 ';           { Do *NOT* change length of this string! }
      TheRegel='A Remote Access doorgame, strict for fun!';

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Type Scores=Record
              Name:String[35];
              Moves:LongInt;
            end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

var c:Char;
    Field:Array [1..4,1..4] of String[2];
    Ex,Ey:Integer;
    Playing,
    Reg,Extended:Boolean;
    moves:LongInt;
    Bfr:String;
    i,j,rx1,rx2,ry1,ry2:Integer;
    HiScr:Array [1..5] of Scores;
    F:File of Scores;
    TheKey:String;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ReadScoreFile(KeepOpen:Boolean);
begin
  Filemode:=$12;
  {$i-}
  Reset(f);
  {$i+}
  if ioresult<>0 then
   begin
     Delay(100);
     {$i-}
     Reset(f);
     {$I+}
     if ioresult<>0 then
     begin
       Rewrite(f);
       For I:=1 to 5 do
         begin
           HiScr[i].Name:='';
           HiScr[i].Moves:=999999;
           write (f,HiScr[i]);
         end;
     If not keepopen then close(f);
     exit;
     end;
     end;
  For I:=1 to 5 do read(f,HiScr[i]);
  If not keepopen then close(f);
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure CloseScoreFile;
begin
  Rewrite(f);
  For I:=1 to 5 do write (f,HiScr[i]);
  Close(f);
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure Introduction;
Var C:Char;
    I:Integer;
    s:String;

begin
  ClrScr;s:=TheRegel;
  Write ('`C:`A14:Prime Productions proudly presents :-');
  Write ('`C:`Y23:`A10:(c) 1993 Hans Siemons / Prime Productions');

  If Doravatar then
    GotoXY((80-Length(TheRegel)) div 2+length(TheRegel),21) else
    GotoXY((80-Length(TheRegel)) div 2+length(TheRegel),3);
  For i:=1 to length(Theregel) do write (s[Length(s)+1-i]+#8+#8);

   if doravatar then GotoXY(1,3) else GotoXY(1,5);
   DorSetHotKeys(#13+#20+#27);
   writeln('`D32,4:`A11:`D196,9:Ŀ Ŀ `D196,9:`D196,9:Ŀ`D32,6:`D196,9:');
   write('`D32,4:`L:`H:`L:`H: `L:`H:`L:`H: `L:`H:`L:`H:`L:`H:`L:`H:');
   writeln('`D32,6:`L:`H:');
   write('`D32,4:`L:`H:`L:`H: `L:`H:`L:`H: `L:`H:`L:`H:`L:`H:`L:`H:');
   writeln('`D32,6:`L:`H:');
   write('`D32,4:`L:`H:`D196,5:`L:`H: `L:`H:`L:`H: `L:`H:`L:`H:`D196,5:`L:`H:`D196,5:');
   writeln('`L:`H:`D32,6:`L:`H:`D196,5:');
   write('`D32,4:`L:`H:`D196,5:`L:`H:`L:`H:`L:`H: `L:`H:`L:`H:Ŀ  `L:`H:Ŀ  `L:`H:');
   writeln('`D32,6:`L:`H:Ŀ');
   write('`D32,4:`L:`H:`L:`H:`L:`H: `L:`H:`L:`H:  `L:`H:  `L:`H:');
   writeln('`D32,6:`L:`H:');
   write('`D32,4:`L:`H:`L:`H:`L:`H: `L:`H:`L:`H:  `L:`H:  `L:`H:');
   writeln('`D32,6:`L:`H:');
   write('`D32,4:`D196,5:`H:`L:`H:`L:`H:`H:`L:`H:`L:`H: `L:`H:`L:`H:  `H:`L:`H:  `H:');
   writeln('`L:`H:`D32,6:`H:`L:`H:');
   write('`D32,4:`H:`D196,5:`L:`H:`L:`H: `L:`H:`L:`H:`L:`H:`L:`H:`D32,5:`L:`H:');
   writeln('`D32,5:`H:`L:`H:Ĵ`L:`H:`D196,5:`H:');
   write('`D32,4:`L:`H:`L:`H: `L:`H:`L:`H:`L:`H:`D32,5:`L:`H:`D32,5:');
   writeln('`L:`H:`L:`H:');
   write('`D32,4:`L:`H:`L:`H: `L:`H:`L:`H:`L:`H:`D32,5:`L:`H:`D32,5:');
   writeln('`L:`H:`L:`H:');
   writeln('`D32,4:`D196,9: `D196,9:`D32,5:`D32,5:`D196,10:`D196,9:');
   DorSethotkeys('');
   If DorAvatar then
   Repeat
     If not keypressed then begin Delay(100);write (#22+#11+#2+#2+#1+#20+#80);end;
     If not keypressed then begin Delay(100);write (#22+#11+#4+#2+#1+#20+#80);end;
     If not keypressed then begin Delay(100);write (#22+#10+#4+#2+#1+#20+#80);end;
     If not keypressed then begin Delay(100);write (#22+#10+#2+#2+#1+#20+#80);end;
     If not keypressed then begin Delay(100);write (#22+#10+#1+#2+#1+#20+#80);end;
     If not keypressed then begin Delay(100);write (#22+#11+#1+#2+#1+#20+#80);end;
   until keypressed
   else
   begin
   Write ('`A0:');
   Repeat
     If not keypressed then begin Delay(100);write (#27+'[4;1H');InsLine;Insline;end;
     If not keypressed then begin Delay(100);write (#27+'[4;1H');InsLine;Insline;InsLine;InsLine;end;
     If not keypressed then begin Delay(100);write (#27+'[4;1H');DelLine;Delline;DelLine;DelLine;end;
     If not keypressed then begin Delay(100);write (#27+'[4;1H');DelLine;DelLine;end;
     If not keypressed then begin Delay(100);write (#27+'[4;1H');DelLine;end;
     If not keypressed then begin Delay(100);write (#27+'[4;1H');InsLine;end;
   until keypressed
   end;
   FosPurgeOutput;
   If Not DorAvatar then clrscr else for i:=1 to 24 do
                                         begin
                                           Write (#22+#11+#1+#1+#1+#23+#80);
                                           delay(20);
                                         end;

end; {Introduction}

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure DrawField;
begin
  Write('`G5,15:`A3:ͻ');
  Write('`G5,16:            ');
  Write('`G5,17:Ķ');
  Write('`G5,18:            ');
  Write('`G5,19:Ķ');
  Write('`G5,20:            ');
  Write('`G5,21:Ķ');
  Write('`G5,22:            ');
  Write('`G5,23:ͼ');
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure TheGame;
Var QuitIt:Boolean;
    Ready:Boolean;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure GameReady;
Var X,Y:integer;
    s:String;
begin
  s:='';
  For y:=1 to 4 do For X:=1 to 4 do s:=s+Field[x,y];
  Ready:=s=' 1 2 3 4 5 6 7 8 9101112131415  ';
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure TryUp;
begin
if Ey=4 then exit;

Field[Ex,Ey]:=Field[Ex,Ey+1];
If playing then begin
                  GotoXY(3+Ex*4,14+EY*2);
                  Write ('`A11:'+Field[Ex,Ey]);
                end;
Inc(Ey);
If playing then begin GotoXY(3+Ex*4,14+EY*2);write ('  ');end;
Field[Ex,Ey]:='  ';
Inc(Moves);
Gameready;
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure TryDown;
begin
if ey=1 then exit;
Field[Ex,Ey]:=Field[Ex,Ey-1];
If playing then begin
                  GotoXY(3+Ex*4,14+EY*2);
                  Write ('`A11:'+Field[Ex,Ey]);
                end;
Dec(Ey);
If playing then begin GotoXY(3+Ex*4,14+EY*2);write ('  ');end;
Field[Ex,Ey]:='  ';
Inc(Moves);
Gameready
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure TryRight;
begin
if ex=1 then exit;
Field[Ex,Ey]:=Field[Ex-1,Ey];
If playing then begin
                  GotoXY(3+Ex*4,14+EY*2);
                  Write ('`A11:'+Field[Ex,Ey]);
                end;
Dec(Ex);
If playing then begin GotoXY(3+Ex*4,14+EY*2);write ('  ');end;
Field[Ex,Ey]:='  ';
Inc(Moves);
Gameready
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure TryLeft;
begin
if ex=4 then exit;
Field[Ex,Ey]:=Field[Ex+1,Ey];
If playing then begin
                  GotoXY(3+Ex*4,14+EY*2);
                  Write ('`A11:'+Field[Ex,Ey]);
                end;
Inc(Ex);
If playing then begin GotoXY(3+Ex*4,14+EY*2);write ('  ');end;
Field[Ex,Ey]:='  ';
Inc(Moves);
Gameready
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

begin
  Write ('`G30,16:`A3:[`H:R`L:] `H:To redraw screen');
  Write ('`G30,17:`A3:[`H:Q`L:] `H:Quit game');
  Write ('`G30,18:`A11:             ');
  Write ('`G30,19:`A11:Use cursorkeys for shuffle');
  Write ('`G30,21:`A2:Moves : `A138:0`A11:');

  For Ex:=1 to 4 do For Ey:=1 to 4 do
    begin
      Field[Ex,Ey]:=FStr(Ex+(Ey-1)*4);
      If Length(Field[Ex,Ey])=1 then Field[Ex,Ey]:=' '+Field[Ex,Ey];
    end;
    Field[4,4]:='  ';

    Randomize;
    ex:=4;
    ey:=4;

     Playing:=False;
     Moves:=0;j:=0;

   repeat
     i:=random(4);
     case i of
        0:if j<>1 then begin
                         TryUp;
                         j:=0;
                       end;
        1:if j<>0 then begin
                         TryDown;
                         j:=1;
                       end;
        2:if j<>3 then begin
                         TryLeft;
                         j:=2;
                       end;
        3:if j<>2 then begin
                         TryRight;
                         j:=3;
                       end;
      end;

   until moves=60;
   Playing:=True;


   For rx1:=1 to 4 do For ry1:=1 to 4 do
     begin
      GotoXY(3+Rx1*4,14+Ry1*2);
      write (Field[Rx1,Ry1]);
    end;

QuitIt:=False;Moves:=0;Ready:=False;
bfr:='';
Repeat
  if bfr='' then c:=UpCase(Readkey) else
  begin
    c:=bfr[1];
    Delete(Bfr,1,1);
  end;

  if c=#0 then begin extended:=True;c:=Readkey;end else extended:=False;
  if extended then
  Case ord(c) of
      72:TryUp;
      75:TryLeft;
      77:TryRight;
      80:TryDown;
   end else
   case c of
     '8':TryUp;
     '4':TryLeft;
     '6':TryRight;
     '2':TryDown;
     'R':DorRefresh;
     'Q':Quitit:=True;
   end;
   Write ('`G38,21:`A138:',moves);
   Uonset('User is playing Shuffle and has '+Fstr(moves)+' moves made so far');

until QuitIt or Ready;

if ready then
           begin
             Write ('`G30,19:`A10:Congratulations, you''ve played');
             Write ('`G30,20:`A10:shuffle in `A138:',Moves,'`A10: smooth moves!');
             Write ('`G30,21:`D32,20:');
             Uonset('User completed a shuffle game in '+FStr(moves)+' moves!');
             ReadScoreFile(True);

             for i:=1 to 5 do if Moves<HiScr[i].Moves then
              begin
                for j:=4 downto I do HiScr[j+1]:=HiScr[j];
                HiScr[i].Name:=Exitinfo.UserInfo.Name;
                HiScr[i].Moves:=Moves;
                i:=5;
              end;
             CloseScoreFile;
             Getkey(#13);
           end;

      if Doravatar then
          For i:=1 to 8 do begin
            Write (#22+#11+#1+#15+#30+#22+#80);
            delay(25);
           end else
           For I:=1 to 8 do begin
             GotoXY(30,14+i);
             Clreol;
           end;

Drawfield;

end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Begin
  DorInit;

  if not (DorAvatar or Doransi) then           { Only avatar and ansi users! }
    begin
      writeln ('Sorry, this door requires ANSI or AVATAR');
      readln;
      halt(0);
    end;

DorStatln[8,1]:='';
DorStatln[8,2]:=CenterJust('Shuffle '+SVersion+' (c) 1993,94 Hans Siemons / Prime Productions !',80,false);
DorExtKeys[ExtKey_CtrlPgUp]:=DorExtKeys[ExtKey_Up]; { Move up-arrow to ^PgUp }
DorExtKeys[ExtKey_CtrlPgDn]:=DorExtKeys[ExtKey_Down];   { Move down to ^PgDn }
DorExtKeys[ExtKey_Up]:=DorNullProc;                         { Clear up-arrow }
DorExtKeys[ExtKey_Down]:=DorNullProc;                     { Clear down-arrow }

Assign(f,DorPath+'SHUFFLE.SCR');
Filemode:=$12;

DorStatLn[9,2]:='     [S]ecurity  [^PgUp]-Inc Time  [^PgDn]-Dec Time  [F1]-[F8]=Extra Stats';

RALog('SHUFFLE : Shuffle coming up. Yet another Prime Productions release');
UOnset('User just entered Shuffle... Shouldn''t you do the same?');
Introduction;

ClrScr;

Write ('`A15:`G1,1:`D220,80:`G1,2:`L:`A112:Shuffle '+SVersion+'`A7:`D219,23:`A112:(c) 1993 Hans Siem');
Write ('ons / Prime Productions `G1,3:`A15:`D223,80:`G1,4:`A10:`D32,4:`D220,15: `D220,9: `D220,29:');
Write ('`G66,4:`D220,11:`G1,5:`D32,4:`L:`D176,9:`H:`L:`H: `L:`H:`L:`H: `L:');
Write ('`H:`L:`D176,9:`H:`L:`D176,9:`H:`L:`H:`G66,5:`L:`D176,9:`H:`G1,6:`D32,4:');
Write ('`L:`H:`D220,6:`L:`H:`L:`H:`L:`H: `L:`H:`L:`H:`D223,6:');
Write ('`L:`H:`D223,6:`L:`H:`G66,6:`L:`H:`D223,7:`G1,7:`D32,4:`L:`D178,9:`H:');
Write ('`L:`D178,9:`H:`L:`H: `L:`H:`L:`D178,6:  `H:`L:`D178,6:`H:  `L:`H:');
Write ('`G66,7:`L:`D178,6:`H:`G1,8:`D32,4:`D220,7:`L:`H:`L:`H:`L:`H:`L:');
Write ('`H:`L:`H:`L:`H:  `L:`H:  `L:`H:`D220,6:`L:`H:`D220,7:');
Write ('`G1,9:`D32,4:`L:`D176,9:`H:`L:`H: `L:`H:`L:`D176,9:`H:`L:`H:`G45,9:');
Write ('`L:`H:`G55,9:`L:`D176,10:`H:`L:`D176,9:`H:`G1,10:`D32,4:`D223,15: `D223,19:');
Write ('`G45,10:`D223,5:`G55,10:`D223,22:`G1,11:`A15:`D220,80:`G1,12:`L:`D219,13:`A112:The tra');
WriteLn ('ditional Shuffle Game... Play it, and enjoy it!`D32,13:`G1,13:`A15:`D223,80:');

DrawField;
Repeat
UOnset('User is thinking what he should do in Shuffle');
Write ('`G30,16:`A3:[`H:P`L:] `H:Play the game');
Write ('`G30,17:`A3:[`H:H`L:] `H:Help!');
Write ('`G30,18:`A3:[`H:S`L:] `H:Hi-Scores');
Write ('`G30,19:`A3:[`H:Q`L:] `H:Quit to BBS');
c:=UPCase(GetKey('PpQqSsHh'));
Case C of
  'Q':Begin
         If Not DorAvatar then clrscr else for i:=1 to 24 do
                                         begin
                                           Write (#22+#11+#1+#1+#1+#23+#80);
                                           delay(20);
                                         end;

        Writeln ('`G1,1:`A15:THANKS!!! `A7:for playing `H:Shuffle '+SVersion+' `L:here.');

        Writeln ('`A7:Returning you to `H:'+RAConfig.Systemname+'`L:.');
        Halt(0);
      end;
  'P':begin
        TheGame;
      end;
  'H':Begin
         UOnset('User is getting some help for the Doorgame Shuffle');
         write ('`G30,15:`A14:Does it need any  introduction? I guess not...');
         write ('`G30,16:Just point the arrow  to the empty square from');
         write ('`G30,17:the  direction you  want a  number moved.  And');
         write ('`G30,18:move and move and move. As soon as the numbers');
         write ('`G30,19:are in order you''re a winner.');
         Write ('`G30,20:Try to  keep the  amount of moves as  small as');
         write ('`G30,21:possible.   They determine  your place  in the');
         write ('`G30,22:hall of fame!');
         GetKey(#13);
         if Doravatar then
          For i:=1 to 8 do begin
            Write (#22+#11+#1+#15+#30+#22+#80);
            delay(30);
           end else
           For I:=1 to 8 do begin
             GotoXY(30,14+i);
             Clreol;
           end;


      end;
  'S':begin
        UOnset('User is looking at the Top shufflers at this bbs');
        Write ('`A15:`G30,15:'+RightJust('Top Shufflers on '+RAConfig.Systemname,49));
        GotoXY(30,16);
        Write (Dup('',49));
        ReadScoreFile(False);
        For I:=1 to 5 do
         begin
           if I=1 then write ('`A142:') else write ('`A14:');
           GotoXY(30,16+i);
           Write (I);
           if HiScr[i].Name<>'' then write ('  '+LeftJust(HiScr[i].name,35)+RightJust(Fstr(HiScr[i].Moves),11))
                                else if i<4 then write ('              ');
         end;
        Getkey(#13);
        if Doravatar then
          For i:=1 to 8 do begin
            Write (#22+#11+#1+#15+#30+#22+#80);
            delay(30);
           end else
           For I:=1 to 7 do begin
             GotoXY(30,14+i);
             Clreol;
           end;
      end;

  end;
until false;
end. { Main }
