{$V-,X+}

Program TimeOut;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    TimeOut

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Demonstrates the use of the DorTimeOut variable to make
              custom messages when the keyboard is idle for a certain period.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function  TimeOutProc (Idle : Word) : Boolean; Far;

Begin { TimeOutProc }
  WriteLn (^G);                                           { Wake up the user }

  If Idle=1 then                             { No key pressed for one minute }
  Begin
    WriteLn ('Press any key within one minute!');
    TimeOutProc:=False;                              { Do not terminate call }
  End;  { If }

  If Idle=2 then                              { No key pressed for 2 minutes }
  Begin
    WriteLn ('Keyboard idle timeout, disconnecting..');
    TimeOutProc:=True;                                      { Terminate call }
  End;  { If }
End;  { TimeOutProc }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Begin { TimeOut }
  DorInit;                                       { Initialises the Door Unit }

  ExitInfo.UserInfo.Language:=105;

  DorTimeOut:=TimeOutProc;                 { Install the new TimeOut handler }

  Write   ('Dont''t press any key a few minutes, and see how this program ');
  WriteLn ('reacts.');
  Write   ('Press enter to stop.',^A);
End.  { TimeOut }
