{$V-,X+}

Program Keyboard;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    Keybard

     Date:    14 august 1992

   Author:    Richard Faasen, In Fase Productions

  Purpose:    Shows how easy it is to access the extended keys pressed
              by a user.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  RADU;

Const
  Control     : Array [#1..#32] of String[20] = (
    'Ctrl-A','Ctrl-B','Ctrl-C','Ctrl-D','Ctrl-E','Ctrl-F','Ctrl-G',
    'BackSpace/Ctrl-H','Tab/Ctrl-I','Ctrl-Enter/Ctrl-J','Ctrl-K',
    'Ctrl-L','Enter/Ctrl-M','Ctrl-N','Ctrl-O','Ctrl-P','Ctrl-Q',
    'Ctrl-R','Ctrl-S','Ctrl-T','Ctrl-U','Ctrl-V','Ctrl-W','Ctrl-X',
    'Ctrl-Y','Ctrl-Z','Esc/Ctrl-[','Ctrl-\','Ctrl-]','Ctrl-6',
    'Ctrl--','Space');

  Extended    : Array [#3..#140] of String[15] = (
    'Ctrl-2','','','','','','','','','','','','Shift-Tab','Alt-Q','Alt-W',
    'Alt-E','Alt-R','Alt-T','Alt-Y','Alt-U','Alt-I','Alt-O','Alt-P','','',
    '','','Alt-A','Alt-S','Alt-D','Alt-F','Alt-G','Alt-H','Alt-J','Alt-K',
    'Alt-L','','','','','','Alt-Z','Alt-X','Alt-C','Alt-V','Alt-B','Alt-N',
    'Alt-M','','','','','','','','','F1','F2','F3','F4','F5','F6','F7','F8',
    'F9','F10','','','Home','Up','PgUp','','Left','','Right','','End',
    'Down','PgDn','Ins','Del','Shift-F1','Shift-F2','Shift-F3','Shift-F4',
    'Shift-F5','Shift-F6','Shift-F7','Shift-F8','Shift-F9','Shift-F10',
    'Ctrl-F1','Ctrl-F2','Ctrl-F3','Ctrl-F4','Ctrl-F5','Ctrl-F6','Ctrl-F7',
    'Ctrl-F8','Ctrl-F9','Ctrl-F10','Alt-F1','Alt-F2','Alt-F3','Alt-F4',
    'Alt-F5','Alt-F6','Alt-F7','Alt-F8','Alt-F9','Alt-F10','Ctrl-PrtScr',
    'Ctrl-Left','Ctrl-Right','Ctrl-End','Ctrl-PgDn','Ctrl-Home','Alt-1',
    'Alt-2','Alt-3','Alt-4','Alt-5','Alt-6','Alt-7','Alt-8','Alt-9','Alt-0',
    'Alt--','Alt-=','Ctrl-PgUp','F11','F12','Shift-F11','Shift-F12',
    'Ctrl-F11','Ctrl-F12','Alt-F11','Alt-F12');

Var
  Key         : Char;

Begin { Keyboard }
  DorInit;                                       { Initialises the Door Unit }

  WriteLn ('With this door you can see which keys are detected by RADU.');
  WriteLn ('Note that not all terminals send the correctly codes for all keys,');
  WriteLn ('so use the codes with care. Some terminal programs have a "doorway"');
  WriteLn ('or "raw" mode, which makes it possible to detect almost any key');
  WriteLn ('Just press some keys. Press escape to quit.');

  Repeat
    Key:=ReadKey;                                                { Get a key }

    Write ('The ');                              { Show who pressed that key }
    If DorSysopKey then
      Write ('sysop ')
    Else
      Write ('user ');
    Write ('pressed ');

    Case Key of                                  { Show what key was pressed }
      #0      : WriteLn (Extended[ReadKey]);
      #1..#32 : WriteLn (Control[Key]);
      '`'     : WriteLn ('``');                                  { RADU code }
    Else
      WriteLn (Key);
    End;  { Case }
  Until Key=#27;

End.  { Keyboard }
