{$A+,B-,D-,E-,F+,I+,L-,N-,O-,R-,S-,V-}

Unit RADULOG;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-

           (c) 1992,98 by AquiSystems Software Dev NL.
This example program has succesfully been tested with Borland Pascal 7.0


     Name:    RaduLog

     Date:    29 March 1993

   Author:    Hans Siemons, Prime Productions

  Purpose:    Demonstrates the use of the FosOutHook

   Remark:    This unit can also be used for debugging purposes.

-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

interface

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Const LogOutput : Boolean=True;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Implementation

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses RADU;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Var f:Text;
    buffer:array[1..2048] of char;         { Buffersize, increase for speed }
    OldExit:pointer;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure Log(c:Char);
begin { Log }
  If LogOutput then Write (f,c);
end; { Log }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure DeInit;
begin { DeInit }
  Close(f);                                        { needed to flush buffer }
  ExitProc:=OldExit;
  halt(exitcode);
end; { DeInit }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

begin { RaduLog }
  Assign(f,'RADUOUT.LOG');                                       { Filename }
  SetTextBuf(f,buffer);
  rewrite(f);
  OldExit:=ExitProc;
  ExitProc:=@DeInit;
  FosOutHook:=Log;
end. { RaduLog }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)
